
; *******************************************************************
; *                     Table Import pour ntdll                     *
; *******************************************************************

create_ntdll_import :
    pushad
    call @F
    db "ntdll.dll",0
@@ :
    call LoadLibraryA
    or eax,eax
    jne @F
sortie_create_ntdll_import :    
    popad
    ret
@@ :
    mov ebp,eax                 ; handle Ntdll
    mov edi, ntdll_table_import
@@ :
    mov esi, edi
    movzx eax, byte ptr [edi]
    add edi,eax                 ; pointe sur le nom suivant
    cmp edi,esi
    je sortie_create_ntdll_import
    inc esi
    push esi                    ; pointe sur le nom en court
    push ebp                   
    call GetProcAddress
    or eax,eax
    je sortie_create_ntdll_import
    mov dword ptr [esi-1], eax
    jmp @B


; *******************************************************************
; *                         TABLE IMPORT                            *
; *******************************************************************

ALIGN 4
ntdll_table_import :
    @NtOpenSection              db (@F-$),"NtOpenSection",0
ALIGN 4
@@ :
    @NtCreateFile               db (@F-$),"NtCreateFile",0
ALIGN 4
@@ :
    @NtClose                    db (@F-$),"NtClose",0
ALIGN 4
@@ :
    @NtQuerySystemInformation   db (@F-$),"NtQuerySystemInformation",0
ALIGN 4
@@ :
    @NtMapViewOfSection         db (@F-$),"NtMapViewOfSection",0
ALIGN 4
@@ :
    @NtUnmapViewOfSection       db (@F-$),"NtUnmapViewOfSection",0
ALIGN 4
@@ :
                                db 0

