; *******************************************************************
; *                           Mappe                                 *
; *******************************************************************
;
; IN  : eax = offset physical address
;       ebx = size of mappage    
; OUT : eax = mappage VirtualAddress
;       ebx = real size of mappage

mappe :
    pushad
    push eax
    push ebx

    push offset OBJET_ATTRIBUTES
    push SECTION_MAP_READ or SECTION_MAP_WRITE 
    push offset handle_opensection
    call dword ptr [@NtOpenSection]

    pop ebx
    pop eax

    push ebx
    mov ecx,esp
    push 0          ; mettre  0
    mov edx,esp

    push PAGE_READWRITE
    push 0
    push 1                          ; ViewShare
    push ecx                        ; pointeur qui reoie la taille relle de la section mappe
                                    ; cette addresse doit contenir "size of mappage"
    push eax                        ; offset physical_pointeur
    push ebx                        ; size of mappage 
    push 0
    push edx                        ; offset handle_map
    push -1
    push dword ptr [handle_opensection]
    call dword ptr [@NtMapViewOfSection]      ; mappe la zone en mmoire utilisateur en lecture et criture 

    push dword ptr [handle_opensection]
    call dword ptr [@NtClose]
    mov dword ptr [handle_opensection], eax

    pop eax
    pop ebx

    mov dword ptr [esp+_eax],eax    
    mov dword ptr [esp+_ebx],ebx
    popad
    ret
