
; #########################################################################
; #########################################################################

create_new_table :
    jmp  @F
ALIGN 4    
    @KeAddSystemServiceTable    dd 0 
@@ :
    pushad

    PLACE_OFFSET_DANS_EBP

    lea esi, dword ptr [ebp+Table_parametres]
    lea edi, dword ptr [ebp+Table]

; -------------------- ajuste les entrees de la table ---------------------
    mov ecx, n_fonction
    mov eax, edi
@@ :
    add dword ptr [eax], ebp
    add eax, 4
    loop @B
; -------------------------------------------------------------------------
    push 2                  ; Table n2
    push esi
    push MaxService
    push MinService
    push edi
    call dword ptr [ebp+@KeAddSystemServiceTable]
    cmp al, 01
    je _success
; -------------------------------------------------------------------------
    push 3                  ; Table n3
    push esi
    push MaxService
    push MinService
    push edi
    call dword ptr [ebp+@KeAddSystemServiceTable]
    cmp al, 01
    je _success
; -------------------------------------------------------------------------
    
    MESSAGE_DEBUG " JediLand : AddSystemServiceTable -> ERROR"

    popad                   
    push dword ptr [esp]    
    push dword ptr [esp]    
    pushad
    PLACE_OFFSET_DANS_EBP           
    lea ebx, dword ptr [ebp+create_new_table]
    mov dword ptr [esp+_pushad+8], ebx          ; pointeur zone  demapper
    mov dword ptr [esp+_pushad], 012345678h     ; fonction ExFreePool 
@ExFreePool equ ($-4)    
    popad
                    ; [esp+8] => buffer pour pointeur zone  demapper
                    ; [esp+4] => address de retour vers filtre int0
                    ; [esp]   => ExFreePool 

    ret     ; demappe le zone mmoire 
            ; et retourne dans le filtre int0  
; -------------------------------------------------------------------------
        
_success :
    MESSAGE_DEBUG " "
    MESSAGE_DEBUG " JediLand : AddSystemServiceTable -> OK"
    MESSAGE_DEBUG " "
    popad
    ret                                         ; retourne dans le filtre int0 

; #########################################################################
; #########################################################################

; ====================================
;                        FONCTION TEST_PRESENT                           
; ====================================
test_present :
    pushad
    cli
    push nb_param_test_present*4        ; long des paramtres
    push _SEH
    push fs:[0]
    mov fs:[0],esp
        mov eax, dword ptr [esp+pointeur_parametre]
        mov dword ptr [eax], mot_magique
        mov dword ptr [eax+04], _version
     
    mov ebp, STATUS_SUCCESS
    jmp sortie_fonction
; ====================================
;                            FONCTION RING0                              
; ====================================
ring0 :
    mov esp,[esp+4]
    ret 
; ====================================
; ====================================
sortie_fonction :
    pop fs:[0]
    add esp,04 
    pop eax         ; long des paramtres.    

    mov esi,esp         ;
    add esi,_pushad     ; Enleve les paramtres de la pile
    mov edi,esi         ; en conservant les donnes du "pushad"  
    add edi,eax         ;
    xor ecx,ecx         ;
    mov cl,_pushad/4    ;
    std                 ;
    rep movsd           ;
    cld                 ;
    add esp,eax         ;
    
    mov dword ptr [esp+_eax],ebp
    popad  
    sti    
    ret     
; ====================================
; ====================================
_SEH :
    pushad
    lea edi,[esp+04+_pushad]

ASSUME edi: ptr POINTEURS_EXCEPTION_LIEE 
     mov ebp,[edi].Err_Struct
;    mov esi,[edi].ExceptionRecord
    mov edi,[edi].ContextRecord

ASSUME edi: ptr CONTEXT 
ASSUME esi: ptr EXCEPTION_RECORD

    mov [edi].regEip, sortie_fonction
    mov [edi].regEsp, ebp
    mov [edi].regEbp, STATUS_ERROR

    MESSAGE_DEBUG " "
    MESSAGE_DEBUG " --> EXCEPTION ERROR <--"
    MESSAGE_DEBUG " "
    popad
    mov eax,ExceptionContinueExecution
    ret
    
; ====================================
; ====================================
debug_print :

    pushad
    xor edx,edx
    int 02Ch
    ; ---> edx==eip ?
dbg_prt_int2C_return :                                  ;
    call dbg_prt_call_return                            ;
dbg_prt_call_return :                                   ; si edx==eip alors winxp
    pop eax                                             ; si edx!=eip alors win2000
    sub eax, (dbg_prt_call_return-dbg_prt_int2C_return) ;
    cmp eax,edx                                         ;
    je @F                                               ; 
; ------------------------- Win 2000 --------------------------------
    lea ecx, dword ptr [esp+4+_pushad]      ; ecx pointe sur SIZEOFString=0 suivie de PointeurString
    jmp int_02D_debug_print
@@ :
; ------------------------- Win XP ----------------------------------
    mov ecx, dword ptr [esp+4+_pushad+4]    ; String     
; -------------------------------------------------------------------
int_02D_debug_print :
    xor edx,edx
    xor eax,eax
    inc eax             ; DebugPrint = 1
    
    int 02Dh
    nop                 ; => Obligatoire <= 

    popad
    ret 08

; #########################################################################
; ====================================
;                            TABLE NTCALL                                
; ====================================

; =========================================================================
    nb_param_test_present       equ 1
    nb_param_ring0              equ 1
; =========================================================================
  ALIGN  4
  Table :
    dd test_present             ; Fonction n 0
    dd ring0                    ; Fonction n 1
; =========================================================================
    n_fonction                  equ    ($-Table)/4
; =========================================================================
  ALIGN  4
  Table_parametres :
    db nb_param_test_present    *4   
    db nb_param_ring0           *4
    dd 0	
; ========================================================================= 
; #########################################################################

Taille_data_code_system equ ($-create_new_table)




 














 






























