
;-------------------------------------------------------------------------
    nb_param_is_ready               equ 1
    nb_param_go_ring0               equ 0
    nb_param_go_ring3               equ 0
;-------------------------------------------------------------------------

include is_ready.asm
include go_ring0.asm
include go_ring3.asm

; ====================================
;                               SEH_Fonction
; ====================================

SEH_Fonction :
    pushad
    lea edi,[esp+04+_pushad]

ASSUME edi: ptr POINTEURS_EXCEPTION_LIEE

    mov ebp,[edi].Err_Struct
    mov esi,[edi].ExceptionRecord
    mov edi,[edi].ContextRecord

ASSUME edi: ptr CONTEXT 
ASSUME esi: ptr EXCEPTION_RECORD

    mov [edi].regEip, retour_fonction_erreur
    mov [edi].regEsp,ebp

    popad
    mov eax,ExceptionContinueExecution
    ret
    
; ====================================
;                           retour_fonction_erreur
; ====================================

retour_fonction_erreur :

    pop fs:[0]
    pop eax
    pop eax                         
    mov dword ptr [esp+_eax],eax    ; longueur des parametres (en nb de byte)
    popad
    push ebx
    mov ebx, [esp+4]                ; adresse retour
    mov dword ptr [esp+4+eax],ebx   ; place adresse retour sur le dernier parametre
    pop ebx
    lea esp,[esp+eax]               ; place esp sur l'adresse retour
    mov eax,STATUS_ERROR
    ret

; ====================================
; ====================================

