; ====================================
;                                Go_Ring0
; ====================================

Go_Ring0 PROC
    push cs
    and dword ptr [esp],011b
    jne @F
    add esp,04              ; dj Ring0
    ret	                ;
; -------------------------------------------------------------------------
@@ :
    add esp,04 
    pushad

    mov ax,ds
    and ax,00000100b         
    jne Go_Ring0_win9x  

    push @F
    push esp
    mov eax,[table_n]
    inc eax             ; Fonction n1
    mov edx,esp
    int 02Eh
@@ :
    popad       ; RING 0   
    ret         ;
; ------------------------------------------------------    

Go_Ring0_win9x :

    push @F
    push fs:[0]
    mov fs:[0],esp
    db 0Fh,0D0h		; invalid opcode
    mov esp, fs:[0]
    pop fs:[0]
    add esp,04 
    popad
    ret
@@ :
    pushad
    lea edi,[esp+04+_pushad]

ASSUME edi: ptr POINTEURS_EXCEPTION_LIEE
    mov edi,[edi].ContextRecord
ASSUME edi: ptr CONTEXT 

    add dword ptr [edi+0B8h], 2        ; Eip - \Retour au Thread
    mov dword ptr [edi+0BCh], 028h     ; CS  - | avec passage
    mov dword ptr [edi+0C8h], 030h     ; SS  - / en Ring0
    
    popad
    xor eax,eax              ; ExceptionContinueExecution
    ret
Go_Ring0 ENDP   

