;#############################################################
;#                           MACROS                          #
;#############################################################

Create_SEH MACRO EP_Fonction

ASSUME fs:nothing
    push EP_Fonction
    push fs:[0]
    mov fs:[0],esp
ENDM
;#############################################################
Restore_SEH MACRO Long_ERR_Structure    ;(nb de dword en plus des 2 obligatoires)

ASSUME fs:nothing
    pop fs:[0]
    add esp, 04h + (Long_ERR_Structure*4)
ENDM
;#############################################################
Annule_SEH MACRO EP_Fonction_SEH
LOCAL boucle, sortie

ASSUME fs:nothing
    pushad
    mov ecx, EP_Fonction_SEH
    mov ebx, dword ptr fs:[018h]
boucle :
    xchg eax,ebx
    mov ebx, [eax]
    cmp dword ptr [ebx], 0FFFFFFFFh
    je sortie
    cmp  [ebx+04],ecx
    jne boucle
    mov ebx,[ebx]
    mov [eax],ebx
sortie :
    popad       
ENDM
;#############################################################
PLACE_OFFSET_DANS_EBP MACRO 
LOCAL suivant
    call suivant
suivant :
    pop ebp
    sub ebp, suivant
ENDM  
;#############################################################
Verif_egal MACRO reg, valeur, texte

LOCAL _ok, suivant

    cmp reg, valeur
    je _ok
    call suivant
    db texte,0
suivant :  
    pop eax  
    db 0Fh,0D0h
_ok :

ENDM
;#############################################################
Verif_registre_different MACRO reg, valeur, texte

LOCAL _ok, suivant

    cmp reg, valeur
    jne _ok
    call suivant
    db texte,0
suivant :  
    pop eax  
    db 0Fh,0D0h
_ok :

ENDM
;#############################################################
Verif_egal2 MACRO reg, valeur, texte

LOCAL _ok, suivant

    cmp reg, valeur
    je _ok
    call suivant
    db texte,0
suivant :  
    pop eax  
    db 0Fh,0B9h
_ok :

ENDM
;#############################################################
Verif_registre_different2 MACRO reg, valeur, texte

LOCAL _ok, suivant

    cmp reg, valeur
    jne _ok
    call suivant
    db texte,0
suivant :  
    pop eax  
    db 0Fh,0B9h
_ok :

ENDM
;#############################################################
MESSAGE_DEBUG MACRO texte

LOCAL suivant, debut

    pushad
    call suivant
debut :    
    db texte,0Ah,0
suivant :
    xor eax,eax
    push eax            ; NULL
    
    PLACE_OFFSET_DANS_EBP

    lea eax,[ebp+debug_print]
    call eax
    popad
ENDM  
;#############################################################
SLEEP   MACRO   time 
    pushad
    push time
    call Sleep
    popad
ENDM  
;#############################################################








    