_pushad     equ 20h
saut        equ dw 0A0Dh

SEH_DEBUG :

Annule_SEH SEH_DEBUG 

    pushad
    lea edi,[esp+04+_pushad]

ASSUME edi: ptr POINTEURS_EXCEPTION_LIEE

    mov esi,[edi].ExceptionRecord
    mov edi,[edi].ContextRecord

ASSUME edi: ptr CONTEXT 
ASSUME esi: ptr EXCEPTION_RECORD

    push edi
    push esi
    call rapport_erreur

    popad
    mov eax,ExceptionContinueSearch 
    ret
; ###################################################################
rapport_erreur :

    pushad
    mov esi,[esp+_pushad+04]
    mov edi,[esp+_pushad+08]  

ASSUME edi: ptr CONTEXT 
ASSUME esi: ptr EXCEPTION_RECORD

    push offset code_erreur_texte
    push dword ptr [esi].ExceptionCode
    call hex2ascii

    push offset eip_erreur_texte 
    push dword ptr [esi].ExceptionAddress 
    call hex2ascii

    mov dword ptr [adresse_erreur_texte], '????'
    mov dword ptr [adresse_erreur_texte+4], '????'
    

    cmp [esi].ExceptionCode,EXCEPTION_ACCESS_VIOLATION
    jne @F

    push offset adresse_erreur_texte
    push dword ptr [esi].ExceptionInformation+4
    call hex2ascii

    mov eax, 'tceL'
    mov ebx, ' eru'
    cmp dword ptr [esi].ExceptionInformation,0
    je _lecture 
    mov eax, 'ircE'
    mov ebx, 'erut'
_lecture :
    mov dword ptr [type_violation],eax
    mov dword ptr [type_violation+04],ebx

@@ :
    push 010h
    push offset titre_messagebox
    push texte_messagebox
    push 0
    call MessageBoxA

    popad
    retn 08
; ################################################################### 
; ###################################################################

;************************************************************
;*  Fonction qui convertie une valeur hexadecimal           *
;*  en chaine de caractres.                                *
;*                                                          *
;* Entre : push pointeur  -> pointeur du buffer caract.    *
;*          push valeur dd -> valeur hex (32bits)           *
;*          call hex2ascii                                  *
;************************************************************

hex2ascii :

        pushad      
        mov       edx,[esp+_pushad+04h] ; -> valeur hex (32bits)
        mov       edi,[esp+_pushad+08h] ; -> pointeur du buffer caract.
        std 
        xor ecx,ecx
        mov cl,08
        add       edi,ecx
        dec edi
boucle_hex2ascii :
        mov       al,dl
        and       al,0Fh 
        add       al,30h 
        cmp       al,39h 
        jbe       @F  
        add       al,07 
@@:
        stosb
        shr       edx,04
        loop      boucle_hex2ascii
        cld                          
        popad
        retn 08
; ###################################################################
; ###################################################################

titre_messagebox            db "Erreur !!!   :(",0
texte_messagebox :    
                            db "Une erreur inconnue vient de se produire dans le module jedi_land.dll !"
                            saut
                            saut
                            db "Erreur : 0x"   
    code_erreur_texte       db            "????????"
                            saut
;                           db "Type : 0x"   
;    type_erreur_texte      db          "????????"
;                           saut                            
                            db "Instruction  l'adresse : 0x"
    eip_erreur_texte        db                             "????????"
                            saut
                            db "L'adresse 0x"
    adresse_erreur_texte    db             "????????"
                            db " a dclench une violation d'accs en "
    type_violation          db "????????"  ; lecture / criture
                            saut
                            saut
                            db "Vous pouvez me prvenir de ce problme en m'envoyant un petit mail : yolejedi@ami-ecs.com" 
                            db 0
; ###################################################################
; ###################################################################
























